/***************************************************************************
*   Copyright (C) 2006 by Michael Kaufmann   *
*   michael@enlighter.de   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

#ifndef KOVPNCONFIGDIALOG_H
#define KOVPNCONFIGDIALOG_H

#include "prefopenvpn.h"
#include "prefgeneral.h"
#include "kovpnconfig.h"

#include <kconfigdialog.h>
#include <kconfigskeleton.h>

/**
   @author Michael Kaufmann <michael@enlighter.de>
*/
class kovpnConfigDialog : public KConfigDialog
{
      Q_OBJECT
   public:
      kovpnConfigDialog * self( QWidget *parent, const char *name, kovpnConfig *config, DialogType dialogType = IconList, int dialogButtons = Default | Ok | Apply | Cancel | Help, ButtonCode defaultButton = Ok, bool modal = false );

      kovpnConfigDialog( QWidget *parent, const char *name, kovpnConfig *config, DialogType dialogType = IconList, int dialogButtons = Default | Ok | Apply | Cancel | Help, ButtonCode defaultButton = Ok, bool modal = false );
      ~kovpnConfigDialog();
   protected slots:
      virtual void slotHelp();
      virtual void updateSettings();
      virtual void updateWidgets();
      virtual void updateWidgetsDefault();

   protected:
      virtual bool hasChanged();
      virtual bool isDefault();    // reimplemented from KConfigDialog for our ToolSelectionWidget

      void debug( const QString & method, const QString & message = "I was called" );

   private:
      kovpnConfigDialog * mSelf;

      prefOpenVPN * mPrefOpenVPN;
      prefGeneral * mPrefGeneral;

      //     kovpnConfig *mConfig;
      //     QStringList mOldConnections;
};

#endif
