#ifndef KOVPNINTERFACE_H
#define KOVPNINTERFACE_H

#include <dcopInterface.h>
#include <openvpnmanager.h>
#include <qmap.h>

/**
   @author Michael Kaufmann <michael@enlighter.de>
*/
class kovpnInterface : virtual public dcopInterface
{
public:
   static kovpnInterface * self();

   ~kovpnInterface();

   void reg( openVPNManager * manager );
   void dereg( openVPNManager * manager );

   /* the DCOP interface functions */
   QCStringList connections();
   QCString status( const QString &id );
   ASYNC connect( const QString &id );
   ASYNC disconnect( const QString &id );

private:
   kovpnInterface();
   QMap < QString, openVPNManager * > managerList;
};

#endif
