/**************************************************************************
*   Copyright (C) 2006 by Michael Kaufmann                                *
*   michael@enlighter.de                                                  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/


#include "configwizard.h"
#include "kovpnconfig.h"

#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>
#include <qstring.h>
#include <iostream>

using namespace std;

static const char description[] =
   I18N_NOOP( "Kovpn Setup Wizard" );

static const char version[] = "0.2.1";

static KCmdLineOptions options[] =
   {
      //    { "+[URL]", I18N_NOOP( "Document to open" ), 0 },
      KCmdLineLastOption
   };

int main( int argc, char **argv )
{
   KAboutData about( "kovpnsetup", I18N_NOOP( "kovpnsetup" ), version, description,
                     KAboutData::License_GPL, "(C) 2006 Michael Kaufmann", 0, 0, "michael@enlighter.de" );
   about.addAuthor( "Michael Kaufmann", 0, "michael@enlighter.de" );
   KCmdLineArgs::init( argc, argv, &about );
   KCmdLineArgs::addCmdLineOptions( options );

   KLocale::setMainCatalogue( "kovpn" );

   KApplication app;

   configWizard *mainWin = 0;

   mainWin = new configWizard();
   app.setMainWidget( mainWin );
   mainWin->show();

   //   if ( ! ( kovpnConfig::self() ) ->startMinimized() ) {
   //     mainWin->show();
   // //   }
   // mainWin has WDestructiveClose flag by default, so it will delete itself.
   return app.exec();
}

