/***************************************************************************
*   Copyright (C) 2006 by Michael Kaufmann   *
*   michael@enlighter.de   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

#ifndef _KOVPNWIDGET_H_
#define _KOVPNWIDGET_H_

#include "kovpnwidgetbase.h"
#include "openvpnmanager.h"

#include <qmap.h>
#include <qsize.h>
#include <klistview.h>
#include <qevent.h>

class kovpnWidget : public kovpnWidgetBase
{
      Q_OBJECT

   public:
      kovpnWidget( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
      ~kovpnWidget();
      /*$PUBLIC_FUNCTIONS$*/

      void reg( openVPNManager * manager );
      void dereg( openVPNManager * manager );
      QSize optimalSize();

      void showEvent( QShowEvent * );
      void hideEvent( QHideEvent * );

   public slots:
      /*$PUBLIC_SLOTS$*/
      void slotOvpnStatusChanged( const QString & id, openVPNManager::states );
      void slotOvpnServerChanged( const QString & id, const QString & server );
      void slotOvpnIPChanged( const QString & id, const QString & ip );
      void slotOvpnUptimeChanged( const QString & id, const int & uptime );

      void ovpnReady( const QString & );
      void ovpnNotReady( const QString & );
      void ovpnPreReady( const QString & );
   protected:
      /*$PROTECTED_FUNCTIONS$*/
      void debug( const QString & method, const QString & message = "I was called" );
      typedef QMap<QString, KListViewItem *> tStatusList;
      typedef QMap<QString, openVPNManager *> tManagerList;
      tStatusList mStatusList;
      tManagerList mManagerList;

   protected slots:
      /*$PROTECTED_SLOTS$*/

};

#endif

