/***************************************************************************
*   Copyright (C) 2006 by Michael Kaufmann   *
*   michael@enlighter.de   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

#ifndef LOGWIDGET_H
#define LOGWIDGET_H

#include "logwidgetbase.h"
#include "openvpnmanager.h"

#include <ktextedit.h>
#include <klineedit.h>

/**
   @author Michael Kaufmann <michael@enlighter.de>
*/
class logWidget : public logWidgetBase
{
      Q_OBJECT
   public:
      logWidget( unsigned int maxLines, QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );

      ~logWidget();

      void reg( openVPNManager * manager );
      void dereg( openVPNManager * manager );

      void setAdvanced( bool advanced );
   public slots:
      void message( const QString & id, const QString & message, openVPNManager::requests );
   protected:
      /*$PROTECTED_FUNCTIONS$*/
      void debug( const QString & method, const QString & message = "I was called" );

      typedef QMap<QString, QWidget *> tTabList;
      typedef QMap<QString, KTextEdit *> tHistoryList;
      typedef QMap<QString, KLineEdit *> tCommandList;

      tTabList mTabList;
      tHistoryList mHistoryList;
      tCommandList mCommandList;

      unsigned int mMaxLines;
      bool mAdvanced;
};

#endif
