/**************************************************************************
*   Copyright (C) 2006 by Michael Kaufmann                                *
*   michael@enlighter.de                                                  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/


#include "kovpn.h"
#include "kovpnconfig.h"
#include "traywindow.h"
#include "openvpnmanager.h"
#include "kovpnwidget.h"
#include "kovpnwidgetbase.h"
#include "kovpninterface.h"

#include <kapplication.h>
#include <dcopclient.h>
#include <kuniqueapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>
#include <ksystemtray.h>
#include <qstring.h>
#include <iostream>

using namespace std;

static const char description[] =
   I18N_NOOP( "A simple OpenVPN GUI" );

static const char version[] = "0.3";

static KCmdLineOptions options[] =
   {
      //    { "+[URL]", I18N_NOOP( "Document to open" ), 0 },
      KCmdLineLastOption
   };

int main( int argc, char **argv )
{
   KAboutData about( "kovpn", I18N_NOOP( "kovpn" ), version, description,
                     KAboutData::License_GPL, "(C) 2006 Michael Kaufmann", 0, 0, "michael@enlighter.de" );
   about.addAuthor( "Michael Kaufmann", 0, "michael@enlighter.de" );
   KCmdLineArgs::init( argc, argv, &about );
   KCmdLineArgs::addCmdLineOptions( options );

   KLocale::setMainCatalogue( "kovpn" );

   KApplication app;
   kovpn *mainWin = new kovpn();

   app.dcopClient() ->registerAs( "kovpn", false );
   app.dcopClient() ->setDefaultObject( kovpnInterface::self() ->objId() );
   app.setMainWidget( mainWin );

   if ( ! ( kovpnConfig::self() ) ->startMinimized() )
   {
      mainWin->show();
   }
   // mainWin has WDestructiveClose flag by default, so it will delete itself.
   return app.exec();
}

