/***************************************************************************
*   Copyright (C) 2006 by Michael Kaufmann   *
*   michael@enlighter.de   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

#ifndef PREFOPENVPN_H
#define PREFOPENVPN_H

#include "prefovpnressource.h"
#include "openvpnmanager.h"
#include "kovpnconfig.h"

#include <qwidget.h>
#include <prefopenvpnlayout.h>


/**
   @author Michael Kaufmann <michael@enlighter.de>
*/
class prefOpenVPN : public prefOpenVPNLayout
{
      Q_OBJECT
   public:
      prefOpenVPN();

      ~prefOpenVPN();

      void updateWidgets();
      void updateWidgetsDefault();
      void updateSettings();
      bool hasChanged();
      bool isDefault();
      //   void show();

      /*    KConfigSkeleton::ItemBool  *itemStartMinimized;
          itemStartMinimized = new KConfigSkeleton::ItemBool( currentGroup(), QString::fromLatin1( "startMinimized" ), mStartMinimized, false );*/

      struct tConnection
      {
         QString mId;
         QString mHost;
         QString mPort;
         bool mSaveMIPassword;
         bool mSaveAccount;
         bool mSavePassphrase;
         bool mReconnect;
         bool mAutoconnect;
         bool mDisconnectOnExit;
      };

   signals:
      void widgetChanged();
   public slots:
      //     void writeConfig();

      void add( bool modify = false );
      void modify();
      void remove();

      void clicked( QListViewItem *item );
   protected:
      void debug( const QString & method, const QString & message = "I was called" );

      prefOvpnRessource * ovpnRessource;
   private:
      typedef QMap<QString, tConnection *> tConnectionMap;

      void readConfig();
      void writeConfig();

      bool mChanged;

      kovpnConfig *mConfig;
      QStringList mConnections;
      tConnectionMap mConnectionMap;
      tConnectionMap mAddConnection;
      tConnectionMap mRemoveConnection;
};

#endif
